#include-once
#include <Array.au3>
#include <IE.au3>
#include <String.au3>
#include <ButtonConstants.au3>

Global $oSB_IE
Global $aSocial_Bookmarks[][2] = _
	[ _
		['delicious', 'http://del.icio.us/post?url=$1&title=$2'], _
		['digg', 'http://digg.com/submit?phase=2&url=$1&title=$2'], _
		['diigo', 'http://secure.diigo.com/post?url=$1&title=$2'], _
		['facebook', 'http://www.facebook.com/share.php?u=$1&t=$2'], _
		['stumbleupon', 'http://www.stumbleupon.com/submit?url=$1&title=$2'], _
		['reddit', 'http://reddit.com/submit?url=$1&title=$2'], _
		['slashdot', 'http://slashdot.org/bookmark.pl?url=$1&title=$2'], _
		['ask', 'http://mystuff.ask.com/mysearch/QuickWebSave?v=2.0&t=webpages&title=$2&url=$1'], _
		['barrapunto', 'http://barrapunto.com/submit.pl?story=$1&subj=$2'], _
		['bitacoras-com', 'http://bitacoras.com/anotaciones/$1'], _
		['blinkbits', 'http://blinkbits.com/bookmarklets/save.php?v=1&source_url=$1&title=$2'], _
		['blinklist', 'http://blinklist.com/index.php?Action=Blink/addblink.php&Url=$1&Title=$2'], _
		['bus_exchange', 'http://bx.businessweek.com/api/add-article-to-bx.tn?url=$1'], _
		['blogmarks', 'http://blogmarks.net/my/new.php?mini=1&url=$1&title=$2'], _
		['care2', 'http://www.care2.com/news/compose?share[link_url]=$1&share[title]=$2'], _
		['co-mments', 'http://co.mments.com/track?url=$1&title=$2'], _
		['current', 'http://current.com/clipper.htm?url=$1&title=$2&src=st'], _
		['dealsplus', 'http://dealspl.us/add.php?ibm=1&url=$1'], _
		['delirious', 'http://de.lirio.us/rubric/post?uri=$1'], _
		['fark', 'http://cgi.fark.com/cgi/farkit.pl?u=$1&h=$2'], _
		['faves', 'http://www.faves.com/Authoring.aspx?u=$1&t=$2'], _
		['feed_me_links', 'http://feedmelinks.com/categorize?from=toolbar&op=submit&name=$2&url=$1&version=0.7'], _
		['fresqui', 'http://mix.fresqui.com/post?url=$1&title=$2'], _
		['friendfeed', 'http://friendfeed.com/share?url=$1&title=$2'], _
		['funp', 'http://funp.com/pages/submit/add.php?title=$2&url=$1&via=tools'], _
		['furl', 'http://furl.net/storeIt.jsp?u=$1&t=$2'], _
		['google_bmarks', 'http://www.google.com/bookmarks/mark?op=edit&bkmk=$1&title=$2'], _
		['kirtsy', 'http://www.kirtsy.com/submit.php?url=$1'], _
		['linkagogo', 'http://www.linkagogo.com/go/AddNoPopup?url=$1&title=$2'], _
		['linkedin', 'http://www.linkedin.com/shareArticle?mini=true&url=$1&title=$2&summary=&source='], _
		['ma-gnolia', 'http://ma.gnolia.com/bookmarklet/add?url=$1&title=$2&description=$3'], _
		['meneame', 'http://meneame.net/submit.php?url=$1'], _
		['mixx', 'http://www.mixx.com/submit?page_url=$1'], _
		['mister_wong', 'http://www.mister-wong.com/index.php?action=addurl&bm_url=$1&bm_description=$3'], _
		['windows_live', 'https://favorites.live.com/quickadd.aspx?url=$1&title$2'], _
		['myspace', 'http://www.myspace.com/Modules/PostTo/Pages/?l=3&u=$1&t=$2'], _
		['n4g', 'http://www.n4g.com/tips.aspx?url=$1&title=$2'], _
		['netscape', 'http://www.netscape.com/submit/?U=$1&T=$2'], _
		['netvouz', 'http://netvouz.com/action/submitBookmark?url=$1&title=$2&popup=no'], _
		['newsvine', 'http://www.newsvine.com/_tools/seed&save?popoff=0&u=$1&h=$2'], _
		['oknotizie', 'http://oknotizie.alice.it/post?url=$1&title=$2'], _
		['propeller', 'http://www.propeller.com/submit/?U=$1&T=$2'], _
		['rawsugar', 'http://www.rawsugar.com/tagger/?turl=$1&tttl=$2'], _
		['rojo', 'http://www.rojo.com/add-subscription/?resource=$1'], _
		['simpy', 'http://www.simpy.com/simpy/LinkAdd.do?href=$1&title=$2'], _
		['smarking', 'http://smarking.com/editbookmark/?url=$1&title=$2'], _
		['sphinn', 'http://sphinn.com/submit.php?url=$1&title=$2'], _
		['spurl', 'http://www.spurl.net/spurl.php?url=$1&title=$2&v=3&blocked=$2'], _
		['squidoo', 'http://www.squidoo.com/lensmaster/bookmark?$1'], _
		['tailrank', 'http://tailrank.com/share/?title=$2&link_href=$1'], _
		['technorati', 'http://www.technorati.com/faves?add=$1'], _
		['twitter', 'http://twitter.com/home?status=$1'], _
		['xanga', 'http://www.xanga.com/private/editorx.aspx?t=$2&u=$1&s='], _
		['yigg', 'http://www.yigg.de/neu?exturl=$1&exttitle=$2'], _
		['yahoo_bmarks', 'http://bookmarks.yahoo.com/toolbar/savebm?opener=tb&u=$1&t=$2'], _
		['ybuzz', 'http://buzz.yahoo.com/buzz?targetUrl=$1&headline=$2&src=sharethis'], _
		['yahoo_my_web', 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u=$1&t=$2'], _
		['odnoklassniki', 'http://www.odnoklassniki.ru/dk?st.cmd=addShare&st.s=1&st._surl=$1&title=$2&st.comments=$3'], _
		['vkontakte', 'http://vkontakte.ru/share.php?url=$1&title=$2&description=$3&image=&noparse=true'] _
	]

Func _SB_ShareBookmark($sSocBookmark, $sURL, $sTitle, $sDesc = '', $bUseIE = True)
	Local $iBookmark = _ArraySearch($aSocial_Bookmarks, $sSocBookmark, 0, 0, 0, 2, 1, 0)
	
	If $iBookmark <> -1 Then
		Local $sLink = $aSocial_Bookmarks[$iBookmark][1]
		
		$sLink = StringReplace($sLink, '$1', _SB_URLToHex($sURL))
		$sLink = StringReplace($sLink, '$2', _SB_URLToHex($sTitle))
		$sLink = StringReplace($sLink, '$3', _SB_URLToHex($sDesc))
		
		If $bUseIE Then
			If Not IsObj($oSB_IE) Or _IEPropertyGet($oSB_IE, 'hWnd') = 0 Then
				$oSB_IE = _IECreate('about:blank')
			EndIf
			
			_IENavigate($oSB_IE, $sLink, 0)
			_IEPropertySet($oSB_IE, 'addressbar', False)
			_IEPropertySet($oSB_IE, 'toolbar', False)
			_IEPropertySet($oSB_IE, 'left', (@DesktopWidth / 2) - 300)
			_IEPropertySet($oSB_IE, 'top', 200)
			_IEPropertySet($oSB_IE, 'width', 600)
			_IEPropertySet($oSB_IE, 'height', 600)
		Else
			ShellExecute($sLink)
		EndIf
		
		Return 1
	EndIf
	
	Return SetError(1, 0, 0)
EndFunc

Func _SB_CreateButtons($iLeft, $iTop, $iBttnW, $iBttnH, $aBookmarks, $sIcons_File, $aIcons_IDs)
	If Not IsArray($aBookmarks) Or UBound($aBookmarks, 0) <> 1 Then
		Return SetError(1, 0, 0)
	EndIf
	
	Local $i_Left = $iLeft
	Local $iBkmrks_Ubnd = UBound($aBookmarks)
	Local $iIDs_Ubnd = UBound($aIcons_IDs)
	Local $aRet[$iBkmrks_Ubnd+1][2] = [[$iBkmrks_Ubnd]]
	
	For $i = 0 To $iBkmrks_Ubnd - 1
		$aRet[$i+1][0] = GUICtrlCreateButton('', $i_Left, $iTop, $iBttnW, $iBttnH, $BS_ICON)
		$aRet[$i+1][1] = $aBookmarks[$i]
		
		GUICtrlSetTip($aRet[$i+1][0], _StringTitleCase($aBookmarks[$i]))
		GUICtrlSetCursor($aRet[$i+1][0], 0)
		
		If $i < $iIDs_Ubnd Then
			GUICtrlSetImage($aRet[$i+1][0], $sIcons_File, $aIcons_IDs[$i]+1)
		EndIf
		
		$i_Left += $iBttnW + 10
	Next
	
	Return $aRet
EndFunc

Func _SB_GetBookmarks()
	Local $sRet = ''
	
	For $i = 0 To UBound($aSocial_Bookmarks) - 1
		$sRet &= $aSocial_Bookmarks[$i][0] & '|'
	Next
	
	Return StringTrimRight($sRet, 1)
EndFunc

Func _SB_GetBookmarkLink($sSocBookmark)
	Local $iBookmark = _ArraySearch($aSocial_Bookmarks, $sSocBookmark, 0, 0, 0, 2, 1, 0)
	
	If $iBookmark <> -1 Then
		Return $aSocial_Bookmarks[$iBookmark][1]
	EndIf
	
	Return SetError(1, 0, 0)
EndFunc

Func _SB_URLToHex($sURLString)
	$sURLString = BinaryToString(StringToBinary($sURLString, 4))
	
	Local $aURLStrSplit = StringSplit($sURLString, "")
	Local $sRetString = ""
	
	For $i = 1 To UBound($aURLStrSplit) - 1
		If Not StringRegExp($aURLStrSplit[$i], '(?i)[a-z]|\.|-|_') Then
			$aURLStrSplit[$i] = "%" & Hex(Asc($aURLStrSplit[$i]), 2)
		EndIf
		
		$sRetString &= $aURLStrSplit[$i]
	Next
	
	Return $sRetString
EndFunc
